package com.tzld.piaoquan.recommend.server.service;

import com.tzld.piaoquan.recommend.server.remote.MilvusRemoteService;
import io.milvus.grpc.SearchResultData;
import io.milvus.param.MetricType;
import io.milvus.param.dml.SearchParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

/**
 * @author dyp
 */
@Service
public class VecSearchService {
    @Autowired
    private MilvusRemoteService milvusRemoteService;

    private String videoCollectionName = "video";

    public List<String> searchVideo(List<Float> vector, int topK) {
        SearchParam param = SearchParam.newBuilder()
                .withCollectionName(videoCollectionName)
                .withMetricType(MetricType.L2)
                .withTopK(topK)
                .withFloatVectors(Arrays.asList(vector))
                .withVectorFieldName("video_vec")
                .withParams("{}")
                .addOutField("video_vec")
                .addOutField("vid")
                .build();
        SearchResultData data = milvusRemoteService.search(param);
        return null;
    }
}
